import Component from '../component';
import { Group, CanvasLike } from '@antv/g-lite';
import { Theme as ThemeType } from './theme';
import Layout from './layout';
import { VNode } from './vnode';
import { IProps } from '../types';
export interface CanvasProps extends IProps {
    context?: CanvasRenderingContext2D;
    width?: number;
    height?: number;
    pixelRatio?: number;
    padding?: number | string | (number | string)[];
    animate?: boolean;
    children?: any;
    px2hd?: any;
    theme?: ThemeType;
    style?: any;
    container?: any;
    renderer?: any;
    createImage?: (src?: string) => HTMLImageElement;
    landscape?: boolean;
}
export interface ComponentContext {
    [key: string]: any;
}
declare class Canvas<P extends CanvasProps = CanvasProps> {
    props: P;
    private updater;
    private theme;
    private gesture;
    private canvas;
    private _ee;
    container: Group;
    context: any;
    children: VNode | VNode[] | null;
    private vNode;
    layout: Layout;
    landscape: boolean;
    canvasElement: CanvasLike;
    constructor(props: P);
    updateComponents(components: Component[]): void;
    update(nextProps: P): Promise<void>;
    render(): Promise<void>;
    emit(type: string, event: any): void;
    on(type: string, listener: any): void;
    off(type: string, listener?: any): void;
    getCanvasEl(): CanvasLike;
    resize(width: number, height: number): void;
    destroy(): void;
}
export default Canvas;
