import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { Group, Text, Circle, Ellipse, Rect, Path, Image, Line, Polygon } from '@antv/g-lite';
import { Arc, Marker, Sector, SmoothPolyline } from '../../shape';
import Gesture from '../../gesture';
import { getTag, registerTag } from '../../jsx/tag';
var EVENT_LIST = [['click', 'onClick'], ['touchstart', 'onTouchStart'], ['touchmove', 'onTouchMove'], ['touchend', 'onTouchEnd'], ['touchendoutside', 'onTouchEndOutside'],
// drage 相关
['dragenter', 'onDragEnter'], ['dragleave', 'onDragLeave'], ['dragover', 'onDragOver'], ['drop', 'onDrop'], ['dragstart', 'onDragStart'], ['drag', 'onDrag'], ['dragend', 'onDragEnd'],
// pan
['panstart', 'onPanStart'], ['pan', 'onPan'], ['panend', 'onPanEnd'],
// press
['pressstart', 'onPressStart'], ['press', 'onPress'], ['pressend', 'onPressEnd'],
// swipe
['swipe', 'onSwipe'],
// pinch
['pinchstart', 'onPinchStart'], ['pinch', 'onPinch'], ['pinchend', 'onPinchEnd']];
// 默认标签
var TagElements = [['group', Group], ['text', Text], ['circle', Circle], ['path', Path], ['ellipse', Ellipse], ['rect', Rect], ['image', Image], ['line', Line], ['polyline', SmoothPolyline], ['polygon', Polygon], ['arc', Arc], ['marker', Marker], ['sector', Sector]];
TagElements.map(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
    type = _ref2[0],
    ShapeClass = _ref2[1];
  registerTag(type, ShapeClass);
});
function createShape(type, props) {
  if (!type) return null;
  var ShapeClass = getTag(type);
  if (!ShapeClass) return null;
  // const result = checkCSSRule(type, originStyle);
  var shape = new ShapeClass(props);
  addEvent(shape, props);
  return shape;
}
function addEvent(shape, props) {
  var gesture = new Gesture(shape);
  EVENT_LIST.forEach(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
      eventName = _ref4[0],
      handlerName = _ref4[1];
    if (!props[handlerName]) return;
    gesture.on(eventName, props[handlerName]);
  });
}
export { createShape, addEvent };