import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import GGesture from '@antv/g-gesture';
var G_SHAPE_EVENT = {
  click: true,
  touchstart: true,
  touchmove: true,
  touchend: true,
  touchendoutside: true,
  dragenter: true,
  dragleave: true,
  dragover: true,
  drop: true,
  dragstart: true,
  drag: true,
  dragend: true
};
var GESTURE_EVENT = {
  panstart: true,
  pan: true,
  panend: true,
  pressstart: true,
  press: true,
  pressend: true,
  swipe: true,
  pinchstart: true,
  pinch: true,
  pinchend: true
};
var Gesture = /*#__PURE__*/function () {
  function Gesture(element) {
    _classCallCheck(this, Gesture);
    this.el = element;
    this.gesture = new GGesture(element);
  }
  _createClass(Gesture, [{
    key: "on",
    value: function on(eventName, listener) {
      var el = this.el,
        gesture = this.gesture;
      if (G_SHAPE_EVENT[eventName]) {
        el.addEventListener(eventName, listener);
        return;
      }
      if (GESTURE_EVENT[eventName]) {
        gesture.on(eventName, listener);
      }
    }
  }, {
    key: "off",
    value: function off(eventName, listener) {
      var el = this.el,
        gesture = this.gesture;
      if (G_SHAPE_EVENT[eventName]) {
        el.removeEventListener(eventName, listener);
        return;
      }
      if (GESTURE_EVENT[eventName]) {
        gesture.off(eventName, listener);
      }
    }
  }]);
  return Gesture;
}();
export default Gesture;