import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { Path, deg2rad } from '@antv/g-lite';
import { isNumberEqual } from '@antv/util';
import { polarToCartesian } from './util/util';
export var Arc = /*#__PURE__*/function (_Path) {
  _inherits(Arc, _Path);
  var _super = _createSuper(Arc);
  function Arc(config) {
    var _this;
    _classCallCheck(this, Arc);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  _createClass(Arc, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      _get(_getPrototypeOf(Arc.prototype), "setAttribute", this).call(this, name, value, force);
      if (['startAngle', 'endAngle', 'r'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        x = _this$parsedStyle.x,
        y = _this$parsedStyle.y,
        startAngle = _this$parsedStyle.startAngle,
        endAngle = _this$parsedStyle.endAngle,
        r = _this$parsedStyle.r,
        anticlockwise = _this$parsedStyle.anticlockwise;
      var path = this.createPath(x, y, startAngle ? deg2rad(startAngle) : 0, endAngle ? deg2rad(endAngle) : Math.PI * 2, r ? r : 0, anticlockwise);
      _get(_getPrototypeOf(Arc.prototype), "setAttribute", this).call(this, 'path', path);
    }
  }, {
    key: "createPath",
    value: function createPath(x, y, startAngle, endAngle, r, anticlockwise) {
      if (endAngle < startAngle) {
        endAngle = endAngle + Math.PI * 2;
      }
      if (r <= 0) {
        return null;
      }
      var start = polarToCartesian(x, y, r, startAngle);
      var end = polarToCartesian(x, y, r, endAngle);
      if (isNumberEqual(endAngle - startAngle, Math.PI * 2)) {
        var middlePoint = polarToCartesian(x, y, r, startAngle + Math.PI);
        return [['M', start.x, start.y], ['A', r, r, 0, 1, 1, middlePoint.x, middlePoint.y], ['A', r, r, 0, 1, 1, start.x, start.y], ['A', r, r, 0, 1, 0, middlePoint.x, middlePoint.y], ['A', r, r, 0, 1, 0, start.x, start.y], ['Z']];
      }
      var arcSweep = endAngle - startAngle <= Math.PI ? 0 : 1;
      return [['M', start.x, start.y], ['A', r, r, 0, arcSweep, anticlockwise ? 0 : 1, end.x, end.y]];
    }
  }]);
  return Arc;
}(Path);