import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { Path } from '@antv/g-lite';
var SYMBOLS = {
  circle: function circle(x, y, r) {
    return [['M', x - r, y], ['A', r, r, 0, 1, 0, x + r, y], ['A', r, r, 0, 1, 0, x - r, y]];
  },
  square: function square(x, y, r) {
    return [['M', x - r, y - r], ['L', x + r, y - r], ['L', x + r, y + r], ['L', x - r, y + r], ['Z']];
  }
};
export var Marker = /*#__PURE__*/function (_Path) {
  _inherits(Marker, _Path);
  var _super = _createSuper(Marker);
  function Marker(config) {
    var _this;
    _classCallCheck(this, Marker);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  _createClass(Marker, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      _get(_getPrototypeOf(Marker.prototype), "setAttribute", this).call(this, name, value, force);
      if (['x', 'y', 'symbol', 'radius'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        _this$parsedStyle$rad = _this$parsedStyle.radius,
        radius = _this$parsedStyle$rad === void 0 ? [0, 0, 0, 0] : _this$parsedStyle$rad,
        _this$parsedStyle$sym = _this$parsedStyle.symbol,
        symbol = _this$parsedStyle$sym === void 0 ? 'circle' : _this$parsedStyle$sym,
        _this$parsedStyle$x = _this$parsedStyle.x,
        x = _this$parsedStyle$x === void 0 ? 0 : _this$parsedStyle$x,
        _this$parsedStyle$y = _this$parsedStyle.y,
        y = _this$parsedStyle$y === void 0 ? 0 : _this$parsedStyle$y;
      var method = SYMBOLS[symbol];
      // radius 表示半径，内部自动格式化成了[]
      var path = method(x, y, radius[0]);
      _get(_getPrototypeOf(Marker.prototype), "setAttribute", this).call(this, 'path', path);
    }
  }]);
  return Marker;
}(Path);