import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { Path } from '@antv/g-lite';
import * as Smooth from './util/smooth';
export var SmoothPolyline = /*#__PURE__*/function (_Path) {
  _inherits(SmoothPolyline, _Path);
  var _super = _createSuper(SmoothPolyline);
  function SmoothPolyline(config) {
    var _this;
    _classCallCheck(this, SmoothPolyline);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  _createClass(SmoothPolyline, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      _get(_getPrototypeOf(SmoothPolyline.prototype), "setAttribute", this).call(this, name, value, force);
      if (['smooth', 'points'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        smooth = _this$parsedStyle.smooth,
        points = _this$parsedStyle.points;
      var pos = points.points;
      var d = [['M', pos[0][0], pos[0][1]]];
      if (smooth) {
        var constaint = [[0, 0], [1, 1]];
        var sps = Smooth.smooth(pos.map(function (d) {
          return {
            x: d[0],
            y: d[1]
          };
        }), false, constaint);
        for (var i = 0, n = sps.length; i < n; i++) {
          var sp = sps[i];
          d.push(['C', sp[1], sp[2], sp[3], sp[4], sp[5], sp[6]]);
        }
      } else {
        var _i;
        var l;
        for (_i = 1, l = pos.length - 1; _i < l; _i++) {
          d.push(['L', pos[_i][0], pos[_i][1]]);
        }
        d.push(['L', pos[l][0], pos[l][1]]);
      }
      _get(_getPrototypeOf(SmoothPolyline.prototype), "setAttribute", this).call(this, 'path', d);
    }
  }]);
  return SmoothPolyline;
}(Path);
SmoothPolyline.tag = 'smooth-polyline';