export declare const DEFAULT_CSS_RULE: {
    group: {
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    text: {
        x: string;
        y: string;
        text: string;
        width: string;
        height: string;
        fontSize: string[];
        fontFamily: string;
        fontStyle: string;
        fontWeight: string[];
        fontVariant: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    circle: {
        cx: string;
        cy: string;
        r: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    path: {
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    ellipse: {
        cy: string;
        cx: string;
        ry: string;
        rx: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    rect: {
        width: string;
        height: string;
        x: string;
        y: string;
        radius: string[];
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    image: {
        width: string;
        height: string;
        x: string;
        y: string;
        img: string;
        src: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    line: {
        x1: string;
        x2: string;
        y1: string;
        y2: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    polyline: {
        points: string;
        smooth: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    polygon: {
        points: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    arc: {
        x: string;
        y: string;
        r: string;
        startAngle: string[];
        endAngle: string[];
        anticlockwise: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    marker: {
        x: string;
        y: string;
        radius: string;
        symbol: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
    sector: {
        x: string;
        y: string;
        startAngle: string[];
        endAngle: string[];
        r: string;
        r0: string;
        anticlockwise: string;
        fillStyle: string;
        font: string;
        globalAlpha: string;
        lineCap: string;
        lineWidth: string[];
        lineJoin: string;
        miterLimit: string;
        shadowBlur: string;
        shadowColor: string;
        shadowOffsetX: string;
        shadowOffsetY: string;
        strokeStyle: string;
        textAlign: string;
        textBaseline: string;
        lineDash: string[];
        shadow: string;
        matrix: string;
        stroke: string;
        fill: string[];
        opacity: string;
        fillOpacity: string;
        strokeOpacity: string;
    };
};
