"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addEvent = addEvent;
exports.createShape = createShape;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _gLite = require("@antv/g-lite");
var _shape = require("../../shape");
var _gesture = _interopRequireDefault(require("../../gesture"));
var _tag = require("../../jsx/tag");
var EVENT_LIST = [['click', 'onClick'], ['touchstart', 'onTouchStart'], ['touchmove', 'onTouchMove'], ['touchend', 'onTouchEnd'], ['touchendoutside', 'onTouchEndOutside'],
// drage 相关
['dragenter', 'onDragEnter'], ['dragleave', 'onDragLeave'], ['dragover', 'onDragOver'], ['drop', 'onDrop'], ['dragstart', 'onDragStart'], ['drag', 'onDrag'], ['dragend', 'onDragEnd'],
// pan
['panstart', 'onPanStart'], ['pan', 'onPan'], ['panend', 'onPanEnd'],
// press
['pressstart', 'onPressStart'], ['press', 'onPress'], ['pressend', 'onPressEnd'],
// swipe
['swipe', 'onSwipe'],
// pinch
['pinchstart', 'onPinchStart'], ['pinch', 'onPinch'], ['pinchend', 'onPinchEnd']];
// 默认标签
var TagElements = [['group', _gLite.Group], ['text', _gLite.Text], ['circle', _gLite.Circle], ['path', _gLite.Path], ['ellipse', _gLite.Ellipse], ['rect', _gLite.Rect], ['image', _gLite.Image], ['line', _gLite.Line], ['polyline', _shape.SmoothPolyline], ['polygon', _gLite.Polygon], ['arc', _shape.Arc], ['marker', _shape.Marker], ['sector', _shape.Sector]];
TagElements.map(function (_ref) {
  var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
    type = _ref2[0],
    ShapeClass = _ref2[1];
  (0, _tag.registerTag)(type, ShapeClass);
});
function createShape(type, props) {
  if (!type) return null;
  var ShapeClass = (0, _tag.getTag)(type);
  if (!ShapeClass) return null;
  // const result = checkCSSRule(type, originStyle);
  var shape = new ShapeClass(props);
  addEvent(shape, props);
  return shape;
}
function addEvent(shape, props) {
  var gesture = new _gesture.default(shape);
  EVENT_LIST.forEach(function (_ref3) {
    var _ref4 = (0, _slicedToArray2.default)(_ref3, 2),
      eventName = _ref4[0],
      handlerName = _ref4[1];
    if (!props[handlerName]) return;
    gesture.on(eventName, props[handlerName]);
  });
}