"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Arc = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _gLite = require("@antv/g-lite");
var _util = require("@antv/util");
var _util2 = require("./util/util");
var Arc = /*#__PURE__*/function (_Path) {
  (0, _inherits2.default)(Arc, _Path);
  var _super = (0, _createSuper2.default)(Arc);
  function Arc(config) {
    var _this;
    (0, _classCallCheck2.default)(this, Arc);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  (0, _createClass2.default)(Arc, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(Arc.prototype), "setAttribute", this).call(this, name, value, force);
      if (['startAngle', 'endAngle', 'r'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        x = _this$parsedStyle.x,
        y = _this$parsedStyle.y,
        startAngle = _this$parsedStyle.startAngle,
        endAngle = _this$parsedStyle.endAngle,
        r = _this$parsedStyle.r,
        anticlockwise = _this$parsedStyle.anticlockwise;
      var path = this.createPath(x, y, startAngle ? (0, _gLite.deg2rad)(startAngle) : 0, endAngle ? (0, _gLite.deg2rad)(endAngle) : Math.PI * 2, r ? r : 0, anticlockwise);
      (0, _get2.default)((0, _getPrototypeOf2.default)(Arc.prototype), "setAttribute", this).call(this, 'path', path);
    }
  }, {
    key: "createPath",
    value: function createPath(x, y, startAngle, endAngle, r, anticlockwise) {
      if (endAngle < startAngle) {
        endAngle = endAngle + Math.PI * 2;
      }
      if (r <= 0) {
        return null;
      }
      var start = (0, _util2.polarToCartesian)(x, y, r, startAngle);
      var end = (0, _util2.polarToCartesian)(x, y, r, endAngle);
      if ((0, _util.isNumberEqual)(endAngle - startAngle, Math.PI * 2)) {
        var middlePoint = (0, _util2.polarToCartesian)(x, y, r, startAngle + Math.PI);
        return [['M', start.x, start.y], ['A', r, r, 0, 1, 1, middlePoint.x, middlePoint.y], ['A', r, r, 0, 1, 1, start.x, start.y], ['A', r, r, 0, 1, 0, middlePoint.x, middlePoint.y], ['A', r, r, 0, 1, 0, start.x, start.y], ['Z']];
      }
      var arcSweep = endAngle - startAngle <= Math.PI ? 0 : 1;
      return [['M', start.x, start.y], ['A', r, r, 0, arcSweep, anticlockwise ? 0 : 1, end.x, end.y]];
    }
  }]);
  return Arc;
}(_gLite.Path);
exports.Arc = Arc;