"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Marker = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _gLite = require("@antv/g-lite");
var SYMBOLS = {
  circle: function circle(x, y, r) {
    return [['M', x - r, y], ['A', r, r, 0, 1, 0, x + r, y], ['A', r, r, 0, 1, 0, x - r, y]];
  },
  square: function square(x, y, r) {
    return [['M', x - r, y - r], ['L', x + r, y - r], ['L', x + r, y + r], ['L', x - r, y + r], ['Z']];
  }
};
var Marker = /*#__PURE__*/function (_Path) {
  (0, _inherits2.default)(Marker, _Path);
  var _super = (0, _createSuper2.default)(Marker);
  function Marker(config) {
    var _this;
    (0, _classCallCheck2.default)(this, Marker);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  (0, _createClass2.default)(Marker, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(Marker.prototype), "setAttribute", this).call(this, name, value, force);
      if (['x', 'y', 'symbol', 'radius'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        _this$parsedStyle$rad = _this$parsedStyle.radius,
        radius = _this$parsedStyle$rad === void 0 ? [0, 0, 0, 0] : _this$parsedStyle$rad,
        _this$parsedStyle$sym = _this$parsedStyle.symbol,
        symbol = _this$parsedStyle$sym === void 0 ? 'circle' : _this$parsedStyle$sym,
        _this$parsedStyle$x = _this$parsedStyle.x,
        x = _this$parsedStyle$x === void 0 ? 0 : _this$parsedStyle$x,
        _this$parsedStyle$y = _this$parsedStyle.y,
        y = _this$parsedStyle$y === void 0 ? 0 : _this$parsedStyle$y;
      var method = SYMBOLS[symbol];
      // radius 表示半径，内部自动格式化成了[]
      var path = method(x, y, radius[0]);
      (0, _get2.default)((0, _getPrototypeOf2.default)(Marker.prototype), "setAttribute", this).call(this, 'path', path);
    }
  }]);
  return Marker;
}(_gLite.Path);
exports.Marker = Marker;