"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SmoothPolyline = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _gLite = require("@antv/g-lite");
var Smooth = _interopRequireWildcard(require("./util/smooth"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var SmoothPolyline = /*#__PURE__*/function (_Path) {
  (0, _inherits2.default)(SmoothPolyline, _Path);
  var _super = (0, _createSuper2.default)(SmoothPolyline);
  function SmoothPolyline(config) {
    var _this;
    (0, _classCallCheck2.default)(this, SmoothPolyline);
    _this = _super.call(this, config);
    _this.updatePath();
    return _this;
  }
  (0, _createClass2.default)(SmoothPolyline, [{
    key: "setAttribute",
    value: function setAttribute(name, value, force) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(SmoothPolyline.prototype), "setAttribute", this).call(this, name, value, force);
      if (['smooth', 'points'].indexOf(name) > -1) {
        this.updatePath();
      }
    }
  }, {
    key: "updatePath",
    value: function updatePath() {
      var _this$parsedStyle = this.parsedStyle,
        smooth = _this$parsedStyle.smooth,
        points = _this$parsedStyle.points;
      var pos = points.points;
      var d = [['M', pos[0][0], pos[0][1]]];
      if (smooth) {
        var constaint = [[0, 0], [1, 1]];
        var sps = Smooth.smooth(pos.map(function (d) {
          return {
            x: d[0],
            y: d[1]
          };
        }), false, constaint);
        for (var i = 0, n = sps.length; i < n; i++) {
          var sp = sps[i];
          d.push(['C', sp[1], sp[2], sp[3], sp[4], sp[5], sp[6]]);
        }
      } else {
        var _i;
        var l;
        for (_i = 1, l = pos.length - 1; _i < l; _i++) {
          d.push(['L', pos[_i][0], pos[_i][1]]);
        }
        d.push(['L', pos[l][0], pos[l][1]]);
      }
      (0, _get2.default)((0, _getPrototypeOf2.default)(SmoothPolyline.prototype), "setAttribute", this).call(this, 'path', d);
    }
  }]);
  return SmoothPolyline;
}(_gLite.Path);
exports.SmoothPolyline = SmoothPolyline;
SmoothPolyline.tag = 'smooth-polyline';